diff -Naur src.pgsql/include/catalog/pg_am.h src.bitmap/include/catalog/pg_am.h
--- src.pgsql/include/catalog/pg_am.h	2006-09-16 17:51:34.000000000 -0700
+++ src.bitmap/include/catalog/pg_am.h	2006-09-17 00:42:16.000000000 -0700
@@ -52,10 +52,12 @@
 	bool		amindexnulls;	/* does AM support NULL index entries? */
 	bool		amstorage;		/* can storage type differ from column type? */
 	bool		amclusterable;	/* does AM support cluster command? */
+	bool		amcanshrink;	/* does AM do anything other than REINDEX in
+								 * VACUUM? */
 	regproc		aminsert;		/* "insert this tuple" function */
 	regproc		ambeginscan;	/* "start new scan" function */
 	regproc		amgettuple;		/* "next valid tuple" function */
-	regproc		amgetmulti;		/* "fetch multiple tuples" function */
+	regproc		amgetbitmap; 	/* "fetch next bitmap" function */ 
 	regproc		amrescan;		/* "restart this scan" function */
 	regproc		amendscan;		/* "end this scan" function */
 	regproc		ammarkpos;		/* "mark current scan position" function */
@@ -78,7 +80,7 @@
  *		compiler constants for pg_am
  * ----------------
  */
-#define Natts_pg_am						23
+#define Natts_pg_am						24
 #define Anum_pg_am_amname				1
 #define Anum_pg_am_amstrategies			2
 #define Anum_pg_am_amsupport			3
@@ -89,36 +91,40 @@
 #define Anum_pg_am_amindexnulls			8
 #define Anum_pg_am_amstorage			9
 #define Anum_pg_am_amclusterable		10
-#define Anum_pg_am_aminsert				11
-#define Anum_pg_am_ambeginscan			12
-#define Anum_pg_am_amgettuple			13
-#define Anum_pg_am_amgetmulti			14
-#define Anum_pg_am_amrescan				15
-#define Anum_pg_am_amendscan			16
-#define Anum_pg_am_ammarkpos			17
-#define Anum_pg_am_amrestrpos			18
-#define Anum_pg_am_ambuild				19
-#define Anum_pg_am_ambulkdelete			20
-#define Anum_pg_am_amvacuumcleanup		21
-#define Anum_pg_am_amcostestimate		22
-#define Anum_pg_am_amoptions			23
+#define Anum_pg_am_amcanshrink			11
+#define Anum_pg_am_aminsert				12
+#define Anum_pg_am_ambeginscan			13
+#define Anum_pg_am_amgettuple			14
+#define Anum_pg_am_amgetbitmap			15
+#define Anum_pg_am_amrescan				16
+#define Anum_pg_am_amendscan			17
+#define Anum_pg_am_ammarkpos			18
+#define Anum_pg_am_amrestrpos			19
+#define Anum_pg_am_ambuild				20
+#define Anum_pg_am_ambulkdelete			21
+#define Anum_pg_am_amvacuumcleanup		22
+#define Anum_pg_am_amcostestimate		23
+#define Anum_pg_am_amoptions			24
 
 /* ----------------
  *		initial contents of pg_am
  * ----------------
  */
 
-DATA(insert OID = 403 (  btree	5 1 1 t t t t f t btinsert btbeginscan btgettuple btgetmulti btrescan btendscan btmarkpos btrestrpos btbuild btbulkdelete btvacuumcleanup btcostestimate btoptions ));
+DATA(insert OID = 403 (  btree	5 1 1 t t t t f t t btinsert btbeginscan btgettuple btgetbitmap btrescan btendscan btmarkpos btrestrpos btbuild btbulkdelete btvacuumcleanup btcostestimate btoptions ));
 DESCR("b-tree index access method");
 #define BTREE_AM_OID 403
-DATA(insert OID = 405 (  hash	1 1 0 f f f f f f hashinsert hashbeginscan hashgettuple hashgetmulti hashrescan hashendscan hashmarkpos hashrestrpos hashbuild hashbulkdelete hashvacuumcleanup hashcostestimate hashoptions ));
+DATA(insert OID = 405 (  hash	1 1 0 f f f f f f t hashinsert hashbeginscan hashgettuple hashgetbitmap hashrescan hashendscan hashmarkpos hashrestrpos hashbuild hashbulkdelete hashvacuumcleanup hashcostestimate hashoptions ));
 DESCR("hash index access method");
 #define HASH_AM_OID 405
-DATA(insert OID = 783 (  gist	100 7 0 f t t t t t gistinsert gistbeginscan gistgettuple gistgetmulti gistrescan gistendscan gistmarkpos gistrestrpos gistbuild gistbulkdelete gistvacuumcleanup gistcostestimate gistoptions ));
+DATA(insert OID = 783 (  gist	100 7 0 f t t t t t t gistinsert gistbeginscan gistgettuple gistgetbitmap gistrescan gistendscan gistmarkpos gistrestrpos gistbuild gistbulkdelete gistvacuumcleanup gistcostestimate gistoptions ));
 DESCR("GiST index access method");
 #define GIST_AM_OID 783
-DATA(insert OID = 2742 (  gin	100 4 0 f f f f t f gininsert ginbeginscan gingettuple gingetmulti ginrescan ginendscan ginmarkpos ginrestrpos ginbuild ginbulkdelete ginvacuumcleanup gincostestimate ginoptions ));
+DATA(insert OID = 2742 (  gin	100 4 0 f f f f t f t gininsert ginbeginscan gingettuple gingetbitmap ginrescan ginendscan ginmarkpos ginrestrpos ginbuild ginbulkdelete ginvacuumcleanup gincostestimate ginoptions ));
 DESCR("GIN index access method");
 #define GIN_AM_OID 2742
+DATA(insert OID = 2886 (  bitmap	1 1 0 f t t t f f f bminsert bmbeginscan bmgettuple bmgetbitmap bmrescan bmendscan bmmarkpos bmrestrpos bmbuild bmbulkdelete bmvacuumcleanup bmcostestimate bmoptions ));
+DESCR("bitmap index access method");
+#define BITMAP_AM_OID 2886
 
 #endif   /* PG_AM_H */
diff -Naur src.pgsql/include/catalog/pg_amop.h src.bitmap/include/catalog/pg_amop.h
--- src.pgsql/include/catalog/pg_amop.h	2006-09-16 17:51:34.000000000 -0700
+++ src.bitmap/include/catalog/pg_amop.h	2006-09-17 00:09:33.000000000 -0700
@@ -892,4 +892,57 @@
 DATA(insert (	2780	0 3  t  2752 ));
 DATA(insert (	2780	0 4  t	1070 ));
 
+/*
+ * the operators for the on-disk bitmap index.
+ */
+DATA(insert (	2887	0 1 f  560 ));	/* abstime */
+DATA(insert (	2888	0 1 f 1070 ));	/* array */
+DATA(insert (	2889	0 1 f 1784 ));	/* bit */
+DATA(insert (	2890	0 1 f	91 ));	/* bool */
+DATA(insert (	2891	0 1 f 1054 ));	/* bpchar */
+DATA(insert (	2892	0 1 f 1955 ));	/* bytea */
+DATA(insert (	2893	0 1 f	92 ));	/* char */
+DATA(insert (	2894	0 1 f  1201 ));	/* cidr */
+DATA(insert (	2895	0 1 f 1093 ));	/* date */
+DATA(insert (	2895 1114 1 f 2347 ));	/* date-timestamp */
+DATA(insert (	2895 1184 1 f 2360 ));	/* date-timestamptz */
+DATA(insert (	2896	0 1 f  620 ));	/* float4 */
+DATA(insert (	2896  701 1 f 1120 ));	/* float48 */
+DATA(insert (	2897	0 1 f  670 ));	/* float8 */
+DATA(insert (	2897  700 1 f 1130 ));	/* float84 */
+DATA(insert (	2898	0 1 f 1201 ));	/* inet */
+DATA(insert (	2899	0 1 f	94 ));	/* int2 */
+DATA(insert (	2899   23 1 f  532 ));	/* int24 */
+DATA(insert (	2899   20 1 f 1862 ));	/* int28 */
+DATA(insert (	2900	0 1 f	96 ));	/* int4 */
+DATA(insert (	2900   21 1 f  533 ));	/* int42 */
+DATA(insert (	2900   20 1 f	15 ));	/* int48 */
+DATA(insert (	2901	0 1 f  410 ));	/* int8 */
+DATA(insert (	2901   21 1 f 1868 ));	/* int82 */
+DATA(insert (	2901   23 1 f  416 ));	/* int84 */
+DATA(insert (	2902	0 1 f 1330 ));	/* interval */
+DATA(insert (	2903	0 1 f 1220 ));	/* macaddr */
+DATA(insert (	2904	0 1 f	93 ));	/* name */
+DATA(insert (	2905	0 1 f 1752 ));	/* numeric */
+DATA(insert (	2906	0 1 f  607 ));	/* oid */
+DATA(insert (	2907	0 1 f  649 ));	/* oidvector */
+DATA(insert (	2908	0 1 f	98 ));	/* text */
+DATA(insert (	2909	0 1 f 1108 ));	/* time */
+DATA(insert (	2910	0 1 f 1320 ));	/* timestamptz */
+DATA(insert (	2910 1082 1 f 2386 ));	/* timestamptz-date */
+DATA(insert (	2910 1114 1 f 2542 ));	/* timestamptz-timestamp */
+DATA(insert (	2911	0 1 f 1550 ));	/* timetz */
+DATA(insert (	2912	0 1 f 1804 ));	/* varbit */
+DATA(insert (	2913	0 1 f	98 ));	/* varchar */
+DATA(insert (	2914	0 1 f 2060 ));	/* timestamp */
+DATA(insert (	2914 1082 1 f 2373 ));	/* timestamp-date */
+DATA(insert (	2914 1184 1 f 2536 ));	/* timestamp-timestamptz */
+DATA(insert (	2915	0 1 f 2316 ));	/* text pattern */
+DATA(insert (	2916	0 1 f 2316 ));	/* varchar pattern */
+DATA(insert (	2917	0 1 f 2328 ));	/* bpchar pattern */
+DATA(insert (	2918	0 1 f 2334 ));	/* name pattern */
+DATA(insert (	2919	0 1 f  900 ));	/* money */
+DATA(insert (	2920	0 1 f  566 ));	/* reltime */
+DATA(insert (	2921	0 1 f  811 ));	/* tinterval */
+
 #endif   /* PG_AMOP_H */
diff -Naur src.pgsql/include/catalog/pg_amproc.h src.bitmap/include/catalog/pg_amproc.h
--- src.pgsql/include/catalog/pg_amproc.h	2006-09-16 17:51:34.000000000 -0700
+++ src.bitmap/include/catalog/pg_amproc.h	2006-09-17 00:09:33.000000000 -0700
@@ -308,4 +308,58 @@
 DATA(insert (	2780	0 3 2743 ));
 DATA(insert (	2780	0 4 2744 ));
 
+/*
+ * the operator routines for the on-disk bitmap index.
+ */
+DATA(insert (	2887	0 1 357 ));		/* abstime */
+DATA(insert (	2888	0 1 382 ));		/* array */
+DATA(insert (	2889	0 1 1596 ));	/* bit */
+DATA(insert (	2890	0 1 1693 ));	/* bool */
+DATA(insert (	2891	0 1 1078 ));	/* bpchar */
+DATA(insert (	2892	0 1 1954 ));	/* bytea */
+DATA(insert (	2893	0 1 358 ));		/* char */
+DATA(insert (	2894	0 1  926 ));	/* cidr */
+DATA(insert (	2895	0 1 1092 ));	/* date */
+DATA(insert (	2895 1114 1 2344 ));	/* date-timestamp */
+DATA(insert (	2895 1184 1 2357 ));	/* date-timestamptz */
+DATA(insert (	2896	0 1 354 ));		/* float4 */
+DATA(insert (	2896  701 1 2194 ));	/* float48 */
+DATA(insert (	2897	0 1 355 ));		/* float8 */
+DATA(insert (	2897  700 1 2195 ));	/* float84 */
+DATA(insert (	2898	0 1  926 ));	/* inet */
+DATA(insert (	2899	0 1 350 ));		/* int2 */
+DATA(insert (	2899   23 1 2190 ));	/* int24 */
+DATA(insert (	2899   20 1 2192 ));	/* int28 */
+DATA(insert (	2900	0 1 351 ));		/* int4 */
+DATA(insert (	2900   20 1 2191 ));	/* int42 */
+DATA(insert (	2900   21 1 2188 ));	/* int48 */
+DATA(insert (	2901	0 1 842 ));		/* int8 */
+DATA(insert (	2901   21 1 2193 ));	/* int82 */
+DATA(insert (	2901   23 1 2189 ));	/* int84 */
+DATA(insert (	2902	0 1 1315 ));	/* interval */
+DATA(insert (	2903	0 1  836 ));	/* macaddr */
+DATA(insert (	2904	0 1 359 ));		/* name */
+DATA(insert (	2905	0 1 1769 ));	/* numeric */
+DATA(insert (	2906	0 1 356 ));		/* oid */
+DATA(insert (	2907	0 1 404 ));		/* oidvector */
+DATA(insert (	2908	0 1 360 ));		/* text */
+DATA(insert (	2909	0 1 1107 ));	/* time */
+DATA(insert (	2910	0 1 1314 ));	/* timestamptz */
+DATA(insert (	2910 1082 1 2383 ));	/* timestamptz-date */
+DATA(insert (	2910 1114 1 2533 ));	/* timestamptz-timestamp */
+DATA(insert (	2911	0 1 1358 ));	/* timetz */
+DATA(insert (	2912	0 1 1672 ));	/* varbit */
+DATA(insert (	2913	0 1 360 ));		/* varchar */
+DATA(insert (	2914	0 1 2045 ));	/* timestamp */
+DATA(insert (	2914 1082 1 2370 ));	/* timestamp-date */
+DATA(insert (	2914 1184 1 2526 ));	/* timestamp-timestamptz */
+DATA(insert (	2915	0 1 2166 ));	/* text pattern */
+DATA(insert (	2916	0 1 2166 ));	/* varchar pattern */
+DATA(insert (	2917	0 1 2180 ));	/* bpchar pattern */
+DATA(insert (	2918	0 1 2187 ));	/* name pattern */
+DATA(insert (	2919	0 1  377 ));	/* money */
+DATA(insert (	2920	0 1 380 ));		/* reltime */
+DATA(insert (	2921	0 1 381 ));		/* tinterval */
+
+
 #endif   /* PG_AMPROC_H */
diff -Naur src.pgsql/include/catalog/pg_namespace.h src.bitmap/include/catalog/pg_namespace.h
--- src.pgsql/include/catalog/pg_namespace.h	2006-09-16 17:51:34.000000000 -0700
+++ src.bitmap/include/catalog/pg_namespace.h	2006-09-17 00:09:33.000000000 -0700
@@ -74,6 +74,9 @@
 DATA(insert OID = 99 ( "pg_toast" PGUID _null_ ));
 DESCR("Reserved schema for TOAST tables");
 #define PG_TOAST_NAMESPACE 99
+DATA(insert OID = 3012  ( "pg_bitmapindex" PGUID _null_ ));
+DESCR("Reserved schema for internal relations of bitmap indexes");
+#define PG_BITMAPINDEX_NAMESPACE 3012
 DATA(insert OID = 2200 ( "public" PGUID _null_ ));
 DESCR("Standard public schema");
 #define PG_PUBLIC_NAMESPACE 2200
diff -Naur src.pgsql/include/catalog/pg_opclass.h src.bitmap/include/catalog/pg_opclass.h
--- src.pgsql/include/catalog/pg_opclass.h	2006-09-16 17:51:34.000000000 -0700
+++ src.bitmap/include/catalog/pg_opclass.h	2006-09-17 00:09:33.000000000 -0700
@@ -208,4 +208,43 @@
 DATA(insert OID = 2779 (	2742	_reltime_ops	PGNSP PGUID  1024 t 703 ));
 DATA(insert OID = 2780 (	2742	_tinterval_ops	PGNSP PGUID  1025 t 704 ));
 
+/*
+ * the operators for the on-disk bitmap index.
+ */
+DATA(insert OID = 2887 (	2886	abstime_ops		PGNSP PGUID  702 t 0 ));
+DATA(insert OID = 2888 (	2886	array_ops		PGNSP PGUID 2277 t 0 ));
+DATA(insert OID = 2889 (	2886	bit_ops			PGNSP PGUID 1560 t 0 ));
+DATA(insert OID = 2890 (	2886	bool_ops		PGNSP PGUID   16 t 0 ));
+DATA(insert OID = 2891 (	2886	bpchar_ops		PGNSP PGUID 1042 t 0 ));
+DATA(insert OID = 2892 (	2886	bytea_ops		PGNSP PGUID   17 t 0 ));
+DATA(insert OID = 2893 (	2886	char_ops		PGNSP PGUID   18 t 0 ));
+DATA(insert OID = 2894 (	2886	cidr_ops		PGNSP PGUID  650 t 0 ));
+DATA(insert OID = 2895 (	2886	date_ops		PGNSP PGUID 1082 t 0 ));
+DATA(insert OID = 2896 (	2886	float4_ops		PGNSP PGUID  700 t 0 ));
+DATA(insert OID = 2897 (	2886	float8_ops		PGNSP PGUID  701 t 0 ));
+DATA(insert OID = 2898 (	2886	inet_ops		PGNSP PGUID  869 t 0 ));
+DATA(insert OID = 2899 (	2886	int2_ops		PGNSP PGUID   21 t 0 ));
+DATA(insert OID = 2900 (	2886	int4_ops        PGNSP PGUID   23 t 0 ));
+DATA(insert OID = 2901 (	2886	int8_ops		PGNSP PGUID   20 t 0 ));
+DATA(insert OID = 2902 (	2886	interval_ops	PGNSP PGUID 1186 t 0 ));
+DATA(insert OID = 2903 (	2886	macaddr_ops		PGNSP PGUID  829 t 0 ));
+DATA(insert OID = 2904 (	2886	name_ops		PGNSP PGUID   19 t 0 ));
+DATA(insert OID = 2905 (	2886	numeric_ops		PGNSP PGUID 1700 t 0 ));
+DATA(insert OID = 2906 (	2886	oid_ops			PGNSP PGUID   26 t 0 ));
+DATA(insert OID = 2907 (	2886	oidvector_ops	PGNSP PGUID   30 t 0 ));
+DATA(insert OID = 2908 (	2886	text_ops		PGNSP PGUID   25 t 0 ));
+DATA(insert OID = 2909 (	2886	time_ops		PGNSP PGUID 1083 t 0 ));
+DATA(insert OID = 2910 (	2886	timestamptz_ops PGNSP PGUID 1184 t 0 ));
+DATA(insert OID = 2911 (	2886	timetz_ops		PGNSP PGUID 1266 t 0 ));
+DATA(insert OID = 2912 (	2886	varbit_ops		PGNSP PGUID 1562 t 0 ));
+DATA(insert OID = 2913 (	2886	varchar_ops		PGNSP PGUID 1043 t 0 ));
+DATA(insert OID = 2914 (	2886	timestamp_ops	PGNSP PGUID 1114 t 0 ));
+DATA(insert OID = 2915 (	2886	text_pattern_ops	PGNSP PGUID   25 f 0 ));
+DATA(insert OID = 2916 (	2886	varchar_pattern_ops PGNSP PGUID 1043 f 0 ));
+DATA(insert OID = 2917 (	2886	bpchar_pattern_ops	PGNSP PGUID 1042 f 0 ));
+DATA(insert OID = 2918 (	2886	name_pattern_ops	PGNSP PGUID   19 f 0 ));
+DATA(insert OID = 2919 (	2886	money_ops		PGNSP PGUID  790 t 0 ));
+DATA(insert OID = 2920 (	2886	reltime_ops		PGNSP PGUID  703 t 0 ));
+DATA(insert OID = 2921 (	2886	tinterval_ops	PGNSP PGUID  704 t 0 ));
+
 #endif   /* PG_OPCLASS_H */
diff -Naur src.pgsql/include/catalog/pg_proc.h src.bitmap/include/catalog/pg_proc.h
--- src.pgsql/include/catalog/pg_proc.h	2006-09-16 17:51:34.000000000 -0700
+++ src.bitmap/include/catalog/pg_proc.h	2006-09-17 00:09:34.000000000 -0700
@@ -658,7 +658,7 @@
 
 DATA(insert OID = 330 (  btgettuple		   PGNSP PGUID 12 f f t f v 2 16 "2281 2281" _null_ _null_ _null_  btgettuple - _null_ ));
 DESCR("btree(internal)");
-DATA(insert OID = 636 (  btgetmulti		   PGNSP PGUID 12 f f t f v 4 16 "2281 2281 2281 2281" _null_ _null_ _null_  btgetmulti - _null_ ));
+DATA(insert OID = 636 (  btgetbitmap		   PGNSP PGUID 12 f f t f v 3 2281 "2281 2281 23" _null_ _null_ _null_  btgetbitmap - _null_ ));
 DESCR("btree(internal)");
 DATA(insert OID = 331 (  btinsert		   PGNSP PGUID 12 f f t f v 6 16 "2281 2281 2281 2281 2281 2281" _null_ _null_ _null_	btinsert - _null_ ));
 DESCR("btree(internal)");
@@ -777,7 +777,7 @@
 
 DATA(insert OID = 440 (  hashgettuple	   PGNSP PGUID 12 f f t f v 2 16 "2281 2281" _null_ _null_ _null_  hashgettuple - _null_ ));
 DESCR("hash(internal)");
-DATA(insert OID = 637 (  hashgetmulti	   PGNSP PGUID 12 f f t f v 4 16 "2281 2281 2281 2281" _null_ _null_ _null_  hashgetmulti - _null_ ));
+DATA(insert OID = 637 (  hashgetbitmap	   PGNSP PGUID 12 f f t f v 3 2281 "2281 2281 23" _null_ _null_ _null_  hashgetbitmap - _null_ ));
 DESCR("hash(internal)");
 DATA(insert OID = 441 (  hashinsert		   PGNSP PGUID 12 f f t f v 6 16 "2281 2281 2281 2281 2281 2281" _null_ _null_ _null_	hashinsert - _null_ ));
 DESCR("hash(internal)");
@@ -1045,7 +1045,7 @@
 
 DATA(insert OID = 774 (  gistgettuple	   PGNSP PGUID 12 f f t f v 2 16 "2281 2281" _null_ _null_ _null_  gistgettuple - _null_ ));
 DESCR("gist(internal)");
-DATA(insert OID = 638 (  gistgetmulti	   PGNSP PGUID 12 f f t f v 4 16 "2281 2281 2281 2281" _null_ _null_ _null_  gistgetmulti - _null_ ));
+DATA(insert OID = 638 (  gistgetbitmap	   PGNSP PGUID 12 f f t f v 3 2281 "2281 2281 23" _null_ _null_ _null_  gistgetbitmap - _null_ ));
 DESCR("gist(internal)");
 DATA(insert OID = 775 (  gistinsert		   PGNSP PGUID 12 f f t f v 6 16 "2281 2281 2281 2281 2281 2281" _null_ _null_ _null_	gistinsert - _null_ ));
 DESCR("gist(internal)");
@@ -3907,7 +3907,7 @@
 /* GIN */
 DATA(insert OID = 2730 (  gingettuple	   PGNSP PGUID 12 f f t f v 2 16 "2281 2281" _null_ _null_ _null_  gingettuple - _null_ ));
 DESCR("gin(internal)");
-DATA(insert OID = 2731 (  gingetmulti	   PGNSP PGUID 12 f f t f v 4 16 "2281 2281 2281 2281" _null_ _null_ _null_  gingetmulti - _null_ ));
+DATA(insert OID = 2731 (  gingetbitmap	   PGNSP PGUID 12 f f t f v 3 2281 "2281 2281 23" _null_ _null_ _null_  gingetbitmap - _null_ ));
 DESCR("gin(internal)");
 DATA(insert OID = 2732 (  gininsert		   PGNSP PGUID 12 f f t f v 6 16 "2281 2281 2281 2281 2281 2281" _null_ _null_ _null_	gininsert - _null_ ));
 DESCR("gin(internal)");
@@ -3946,6 +3946,34 @@
 DATA(insert OID = 2749 (  arraycontained	   PGNSP PGUID 12 f f t f i 2 16 "2277 2277" _null_ _null_ _null_ arraycontained - _null_ ));
 DESCR("is contained by");
 
+
+/* the bitmap index access method routines */
+DATA(insert OID = 2884 (  bmgettuple		   PGNSP PGUID 12 f f t f v 2 16 "2281 2281" _null_ _null_ _null_  bmgettuple - _null_ ));
+DESCR("bitmap(internal)");
+DATA(insert OID = 2885 (  bmgetbitmap		   PGNSP PGUID 12 f f t f v 3 2281 "2281 2281 23" _null_ _null_ _null_  bmgetbitmap - _null_ ));
+DESCR("bitmap(internal)");
+DATA(insert OID = 3001 (  bminsert		   PGNSP PGUID 12 f f t f v 6 16 "2281 2281 2281 2281 2281 2281" _null_ _null_ _null_	bminsert - _null_ ));
+DESCR("bitmap(internal)");
+DATA(insert OID = 3002 (  bmbeginscan	   PGNSP PGUID 12 f f t f v 3 2281 "2281 2281 2281" _null_ _null_ _null_	bmbeginscan - _null_ ));
+DESCR("bitmap(internal)");
+DATA(insert OID = 3003 (  bmrescan		   PGNSP PGUID 12 f f t f v 2 2278 "2281 2281" _null_ _null_ _null_	bmrescan - _null_ ));
+DESCR("bitmap(internal)");
+DATA(insert OID = 3004 (  bmendscan		   PGNSP PGUID 12 f f t f v 1 2278 "2281" _null_ _null_ _null_	bmendscan - _null_ ));
+DESCR("bitmap(internal)");
+DATA(insert OID = 3005 (  bmmarkpos		   PGNSP PGUID 12 f f t f v 1 2278 "2281" _null_ _null_ _null_	bmmarkpos - _null_ ));
+DESCR("bitmap(internal)");
+DATA(insert OID = 3006 (  bmrestrpos		   PGNSP PGUID 12 f f t f v 1 2278 "2281" _null_ _null_ _null_	bmrestrpos - _null_ ));
+DESCR("bitmap(internal)");
+DATA(insert OID = 3007 (  bmbuild		   PGNSP PGUID 12 f f t f v 3 2281 "2281 2281 2281" _null_ _null_ _null_ bmbuild - _null_ ));
+DESCR("bitmap(internal)");
+DATA(insert OID = 3008 (  bmbulkdelete	   PGNSP PGUID 12 f f t f v 4 2281 "2281 2281 2281 2281" _null_ _null_ _null_ bmbulkdelete - _null_ ));
+DESCR("bitmap(internal)");
+DATA(insert OID = 3009 (  bmvacuumcleanup   PGNSP PGUID 12 f f t f v 2 2281 "2281 2281" _null_ _null_ _null_ bmvacuumcleanup - _null_ ));
+DATA(insert OID = 3010 (  bmcostestimate   PGNSP PGUID 12 f f t f v 8 2278 "2281 2281 2281 2281 2281 2281 2281 2281" _null_ _null_ _null_  bmcostestimate - _null_ ));
+DESCR("bitmap(internal)");
+DATA(insert OID = 3011 (  bmoptions		   PGNSP PGUID 12 f f t f s 2 17 "1009 16" _null_ _null_ _null_  bmoptions - _null_ ));
+DESCR("btree(internal)");
+
 /*
  * Symbolic values for provolatile column: these indicate whether the result
  * of a function is dependent *only* on the values of its explicit arguments,
diff -Naur src.pgsql/include/nodes/execnodes.h src.bitmap/include/nodes/execnodes.h
--- src.pgsql/include/nodes/execnodes.h	2006-09-16 17:51:34.000000000 -0700
+++ src.bitmap/include/nodes/execnodes.h	2006-09-17 00:09:33.000000000 -0700
@@ -847,6 +847,9 @@
 	PlanState	ps;				/* its first field is NodeTag */
 	PlanState **bitmapplans;	/* array of PlanStates for my inputs */
 	int			nplans;			/* number of input plans */
+	bool*		isStream;		/* if each subplan returning stream bitmaps */
+	HashBitmap *hashBitmap;		/* output hash bitmap */
+	StreamBitmap *streamBitmap;	/* output stream bitmap */
 } BitmapAndState;
 
 /* ----------------
@@ -858,6 +861,9 @@
 	PlanState	ps;				/* its first field is NodeTag */
 	PlanState **bitmapplans;	/* array of PlanStates for my inputs */
 	int			nplans;			/* number of input plans */
+	bool*		isStream;		/* if each subplan returning stream bitmaps */
+	HashBitmap *hashBitmap;		/* output hash bitmap */
+	StreamBitmap *streamBitmap;	/* output stream bitmap */
 } BitmapOrState;
 
 /* ----------------------------------------------------------------
@@ -961,7 +967,8 @@
 typedef struct BitmapIndexScanState
 {
 	ScanState	ss;				/* its first field is NodeTag */
-	TIDBitmap  *biss_result;
+	HashBitmap *hashBitmap;		/* output hash bitmap */
+	StreamBitmap *streamBitmap;	/* output stream bitmap */
 	ScanKey		biss_ScanKeys;
 	int			biss_NumScanKeys;
 	IndexRuntimeKeyInfo *biss_RuntimeKeys;
@@ -986,7 +993,7 @@
 {
 	ScanState	ss;				/* its first field is NodeTag */
 	List	   *bitmapqualorig;
-	TIDBitmap  *tbm;
+	Node  *tbm;
 	TBMIterateResult *tbmres;
 } BitmapHeapScanState;
 
diff -Naur src.pgsql/include/nodes/nodes.h src.bitmap/include/nodes/nodes.h
--- src.pgsql/include/nodes/nodes.h	2006-09-16 17:51:34.000000000 -0700
+++ src.bitmap/include/nodes/nodes.h	2006-09-17 00:09:33.000000000 -0700
@@ -334,7 +334,8 @@
 	 */
 	T_TriggerData = 900,		/* in commands/trigger.h */
 	T_ReturnSetInfo,			/* in nodes/execnodes.h */
-	T_TIDBitmap					/* in nodes/tidbitmap.h */
+	T_HashBitmap,				/* in nodes/tidbitmap.h */
+	T_StreamBitmap				/* in nodes/tidbitmap.h */
 } NodeTag;
 
 /*
diff -Naur src.pgsql/include/nodes/tidbitmap.h src.bitmap/include/nodes/tidbitmap.h
--- src.pgsql/include/nodes/tidbitmap.h	2006-09-16 17:51:34.000000000 -0700
+++ src.bitmap/include/nodes/tidbitmap.h	2006-09-17 00:09:33.000000000 -0700
@@ -22,15 +22,80 @@
 #ifndef TIDBITMAP_H
 #define TIDBITMAP_H
 
+#include "c.h"
+#include "access/htup.h"
+#include "nodes/nodes.h"
+#include "nodes/pg_list.h"
 #include "storage/itemptr.h"
+#include "storage/bufpage.h"
+  
+/*
+ * The maximum number of tuples per page is not large (typically 256 with
+ * 8K pages, or 1024 with 32K pages).  So there's not much point in making
+ * the per-page bitmaps variable size.	We just legislate that the size
+ * is this:
+ */
+#define MAX_TUPLES_PER_PAGE  MaxHeapTuplesPerPage
+
+/*
+ * When we have to switch over to lossy storage, we use a data structure
+ * with one bit per page, where all pages having the same number DIV
+ * PAGES_PER_CHUNK are aggregated into one chunk.  When a chunk is present
+ * and has the bit set for a given page, there must not be a per-page entry
+ * for that page in the page table.
+ *
+ * We actually store both exact pages and lossy chunks in the same hash
+ * table, using identical data structures.	(This is because dynahash.c's
+ * memory management doesn't allow space to be transferred easily from one
+ * hashtable to another.)  Therefore it's best if PAGES_PER_CHUNK is the
+ * same as MAX_TUPLES_PER_PAGE, or at least not too different.	But we
+ * also want PAGES_PER_CHUNK to be a power of 2 to avoid expensive integer
+ * remainder operations.  So, define it like this:
+ */
+#define PAGES_PER_CHUNK  (BLCKSZ / 32)
 
+/* The bitmap unit size can be adjusted by changing these declarations: */
+#define TBM_BITS_PER_BITMAPWORD 32
+typedef uint32 tbm_bitmapword;		/* must be an unsigned type */
+
+/* number of active words for an exact page: */
+#define WORDS_PER_PAGE	((MAX_TUPLES_PER_PAGE - 1) / TBM_BITS_PER_BITMAPWORD + 1)
+/* number of active words for a lossy chunk: */
+#define WORDS_PER_CHUNK  ((PAGES_PER_CHUNK - 1) / TBM_BITS_PER_BITMAPWORD + 1)
 
 /*
- * Actual bitmap representation is private to tidbitmap.c.	Callers can
- * do IsA(x, TIDBitmap) on it, but nothing else.
+ * The hashtable entries are represented by this data structure.  For
+ * an exact page, blockno is the page number and bit k of the bitmap
+ * represents tuple offset k+1.  For a lossy chunk, blockno is the first
+ * page in the chunk (this must be a multiple of PAGES_PER_CHUNK) and
+ * bit k represents page blockno+k.  Note that it is not possible to
+ * have exact storage for the first page of a chunk if we are using
+ * lossy storage for any page in the chunk's range, since the same
+ * hashtable entry has to serve both purposes.
  */
-typedef struct TIDBitmap TIDBitmap;
+typedef struct PagetableEntry
+{
+	BlockNumber blockno;		/* page number (hashtable key) */
+	bool		ischunk;		/* T = lossy storage, F = exact */
+	tbm_bitmapword	words[Max(WORDS_PER_PAGE, WORDS_PER_CHUNK)];
+} PagetableEntry;
+  
+  /*
+   * Actual bitmap representation is private to tidbitmap.c.	Callers can
+ * do IsA(x, HashBitmap) on it, but nothing else.
+   */
+typedef struct HashBitmap HashBitmap;
 
+/*
+ * Stream bitmap representation.
+ */
+typedef struct StreamBitmap
+{
+	NodeTag			type;		/* to make it a valid Node */
+	PagetableEntry	entry;		/* a page of tids in this stream bitmap */
+	BlockNumber		nextBlockNo;/* next block no to be read */
+} StreamBitmap;
+  
 /* Result structure for tbm_iterate */
 typedef struct
 {
@@ -40,18 +105,24 @@
 } TBMIterateResult;				/* VARIABLE LENGTH STRUCT */
 
 /* function prototypes in nodes/tidbitmap.c */
+extern HashBitmap *tbm_create(long maxbytes);
+extern StreamBitmap *tbm_create_stream();
+extern void tbm_free(HashBitmap *tbm);
+
+extern void tbm_add_tuples(HashBitmap *tbm, const ItemPointer tids, int ntids);
+extern void tbm_union(HashBitmap *a, const HashBitmap *b);
+extern void tbm_intersect(HashBitmap *a, const HashBitmap *b);
+
+extern StreamBitmap *
+tbm_hash_to_stream(HashBitmap* hashBitmap, BlockNumber blockno);
+extern void
+tbm_construct_stream_and(List *streamBitmaps, StreamBitmap** out_p);
+extern void
+tbm_construct_stream_or(List *streamBitmaps, StreamBitmap** out_p);
 
-extern TIDBitmap *tbm_create(long maxbytes);
-extern void tbm_free(TIDBitmap *tbm);
-
-extern void tbm_add_tuples(TIDBitmap *tbm, const ItemPointer tids, int ntids);
-
-extern void tbm_union(TIDBitmap *a, const TIDBitmap *b);
-extern void tbm_intersect(TIDBitmap *a, const TIDBitmap *b);
-
-extern bool tbm_is_empty(const TIDBitmap *tbm);
+extern bool tbm_is_empty(const HashBitmap *tbm);
 
-extern void tbm_begin_iterate(TIDBitmap *tbm);
-extern TBMIterateResult *tbm_iterate(TIDBitmap *tbm);
+extern void tbm_begin_iterate(HashBitmap *tbm);
+extern bool tbm_iterate(Node *tbm, TBMIterateResult *output);
 
 #endif   /* TIDBITMAP_H */
diff -Naur src.pgsql/include/utils/rel.h src.bitmap/include/utils/rel.h
--- src.pgsql/include/utils/rel.h	2006-09-16 17:51:34.000000000 -0700
+++ src.bitmap/include/utils/rel.h	2006-09-17 00:09:34.000000000 -0700
@@ -106,7 +106,8 @@
 	FmgrInfo	aminsert;
 	FmgrInfo	ambeginscan;
 	FmgrInfo	amgettuple;
-	FmgrInfo	amgetmulti;
+	FmgrInfo	amgetbitmap;
+	FmgrInfo	amgetbitmapwords;
 	FmgrInfo	amrescan;
 	FmgrInfo	amendscan;
 	FmgrInfo	ammarkpos;
diff -Naur src.pgsql/include/utils/selfuncs.h src.bitmap/include/utils/selfuncs.h
--- src.pgsql/include/utils/selfuncs.h	2006-09-16 17:51:34.000000000 -0700
+++ src.bitmap/include/utils/selfuncs.h	2006-09-17 00:09:34.000000000 -0700
@@ -170,5 +170,6 @@
 extern Datum hashcostestimate(PG_FUNCTION_ARGS);
 extern Datum gistcostestimate(PG_FUNCTION_ARGS);
 extern Datum gincostestimate(PG_FUNCTION_ARGS);
+extern Datum bmcostestimate(PG_FUNCTION_ARGS);
 
 #endif   /* SELFUNCS_H */
diff -Naur src.pgsql/test/regress/sql/create_index.sql src.bitmap/test/regress/sql/create_index.sql
--- src.pgsql/test/regress/sql/create_index.sql	2006-09-16 17:51:36.000000000 -0700
+++ src.bitmap/test/regress/sql/create_index.sql	2006-09-17 00:09:00.000000000 -0700
@@ -259,3 +259,18 @@
 \d concur_heap
 
 DROP TABLE concur_heap;
+
+--
+-- bitmap
+--
+
+SET enable_seqscan = OFF;
+SET enable_indexscan = ON;
+SET enable_bitmapscan = ON;
+
+create table bm_test (i int);
+insert into bm_test select i/10 from generate_series(1, 100) i;
+create index bm_test_idx on bm_test using bitmap (i);
+select i, count(*) from bm_test group by 1 order by 1;
+select count(*) from bm_test where i in(1, 2);
+drop table bm_test;
diff -Naur src.pgsql/test/regress/sql/oidjoins.sql src.bitmap/test/regress/sql/oidjoins.sql
--- src.pgsql/test/regress/sql/oidjoins.sql	2006-09-16 17:51:36.000000000 -0700
+++ src.bitmap/test/regress/sql/oidjoins.sql	2006-09-17 00:09:01.000000000 -0700
@@ -33,10 +33,10 @@
 FROM	pg_catalog.pg_am fk 
 WHERE	amgettuple != 0 AND 
 	NOT EXISTS(SELECT 1 FROM pg_catalog.pg_proc pk WHERE pk.oid = fk.amgettuple);
-SELECT	ctid, amgetmulti 
+SELECT	ctid, amgetbitmap 
 FROM	pg_catalog.pg_am fk 
-WHERE	amgetmulti != 0 AND 
-	NOT EXISTS(SELECT 1 FROM pg_catalog.pg_proc pk WHERE pk.oid = fk.amgetmulti);
+WHERE	amgetbitmap != 0 AND 
+	NOT EXISTS(SELECT 1 FROM pg_catalog.pg_proc pk WHERE pk.oid = fk.amgetbitmap);
 SELECT	ctid, amrescan 
 FROM	pg_catalog.pg_am fk 
 WHERE	amrescan != 0 AND 
